// C Source File
// Created 1/3/01; 4:34:14 PM
// Method for calculating the Hypergeometric probability
// density function (p.d.f.).
// (C) 2001 by Michael S. Beeler

#define SAVE_SCREEN           // Save/Restore LCD Contents
#define RETURN_VALUE

#include <tigcclib.h>         // Include All Header Files

short _ti89;                  // Produce .89Z File
short _ti92plus;              // Produce .9XZ File

float factorial(float x)  		// A floating point method
{															// for getting n!  This
	float fac = 1.0;						// avoids limitations on
	float i = 2.0;							// sizes of integers.
	while(i <= x)
	{
		fac = fac*i;
		i = i + 1.0;
	}
	return fac;
	
}

float combs(float n, float r)		// floating combinations
{
	return (factorial(n))/((factorial(r))*(factorial(n-r))); 
}

// Main Function
void _main(void)
{
	ESI argptr = top_estack;
	unsigned long a=0, b=0, c=0, d=0;
	float n, N1, N, x;
	float hygpdf;
	a = GetIntArg (argptr);				// Force user to
	b = GetIntArg (argptr);				// use integer inputs.
	c = GetIntArg (argptr);       // Default value is 0
	d = GetIntArg (argptr);				// regardless of user input
	if(a <= c && b <= c && d <= a && d <= b && (a-d) <= (c-b))
	// error checking to enforce rules which stem from
	// the definition of the hypergeometric distribution
	{
		n  =  a*1.0;	 							// Convert ints to floats
		N1 =  b*1.0;
		N  =  c*1.0;
		x  =  d*1.0;
		// While loop to clear stack.  Borrowed from example code.
		while (GetArgType (top_estack) != END_TAG)
    	top_estack = next_expression_index (top_estack);
  	top_estack--;
  	hygpdf=((combs(N1,x))*combs((N-N1),(n-x)))/(combs(N,n));
  	push_Float(hygpdf);
  }
  else
  {
  	push_quantum (UNDEF_TAG);
  }
}
